#pragma once

#include <string>
#include <GL\glew.h>
#include <GLFW\glfw3.h>

namespace acidInterstate {

	class Shader
	{
	public:
		Shader(const std::string& vertexShader, const std::string& fragmentShader);
		Shader( const std::string& vertexShader, const std::string& geometryShader, const std::string& fragmentShader );
		~Shader();

		void useShader() const;
		void link();
		void attachShader(GLuint& handle);
		GLuint programHandle;


	private:
		void loadShader( const std::string& shader, GLenum shaderType, GLuint& handle );

		GLuint vertexHandle;
		GLuint fragmentHandle;
		GLuint geometryHandle;
	};
}