#include "TextureClass.h"
#include <iostream>
#include <FreeImage\FreeImage.h>


using namespace acidInterstate;

TextureClass::TextureClass(const char* path)
{
	//mipMapping = 0; 
	//textureSampling = false; 
	glGenTextures(1, &handle);

	glActiveTexture(GL_TEXTURE0);
	glBindTexture(GL_TEXTURE_2D, handle);
	if (mipMapping == 0 && textureSampling)
	{
		glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_NEAREST);
		glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, GL_NEAREST);
	}
	else if (mipMapping == 1 && textureSampling)
	{
		glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_NEAREST_MIPMAP_NEAREST);
		glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, GL_NEAREST);
	}
	else if (mipMapping == 2 && textureSampling)
	{
		glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_NEAREST_MIPMAP_LINEAR);
		glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, GL_NEAREST);
	}else if (mipMapping == 0 && !textureSampling)
	{
		glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_LINEAR);
		glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, GL_LINEAR);
	}
	else if (mipMapping == 1 && !textureSampling)
	{
		glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_LINEAR_MIPMAP_NEAREST);
		glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, GL_LINEAR);
	}
	else if (mipMapping == 2 && !textureSampling)
	{
		glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_LINEAR_MIPMAP_LINEAR);
		glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, GL_LINEAR);
	}




	//glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_LINEAR_MIPMAP_LINEAR);
	//glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, GL_LINEAR);

	FIBITMAP* image = FreeImage_Load(
		FreeImage_GetFileType(path, 0),
		path);

	FIBITMAP *data = FreeImage_ConvertTo32Bits(image);
	int width = FreeImage_GetWidth(data);
	int height = FreeImage_GetHeight(data);

	glTexImage2D(GL_TEXTURE_2D, 0, GL_RGBA8, width, height, 0, GL_BGRA, GL_UNSIGNED_BYTE, (void*)FreeImage_GetBits(data));

	glGenerateMipmap(GL_TEXTURE_2D);

	FreeImage_Unload(data);
}

TextureClass::~TextureClass()
{
	glDeleteTextures(1, &handle);
}

void TextureClass::bind(int unit)
{
	glActiveTexture(GL_TEXTURE0 + unit);
	glBindTexture(GL_TEXTURE_2D, handle);
}

void TextureClass::setMipMapping(int mipMapping)
{
	this->mipMapping = mipMapping;
}

void TextureClass::setTextureSampling(bool textureSampling)
{
	this->textureSampling = textureSampling; 
}