#version 330

in vec3 position; 
in vec3 normal; 
in vec2 uv;

out vec3 fragNormal;
out vec3 fragPos;
out vec2 fragUV; 

uniform mat4 model; 
uniform mat4 view; 
uniform mat4 projection;

void main(){
	fragUV = uv; 
	fragNormal = mat3(transpose(inverse(model))) * normal; 
	fragPos = vec3(model * vec4(position, 1));
	gl_Position = projection * view * model * vec4(position,1);
}