#version 330 core

layout (location = 0) in vec2 position;
layout (location = 1) in vec2 aTexCoord;

out vec2 TexCoord;

uniform vec4 transform;

void main()
{
	// scale in zw and position in xy
	vec2 screenPosition = position * transform.zw + transform.xy;

	//convert to OpenGL coordinate system (with (0,0) in center of screen)
	screenPosition.x = screenPosition.x * 2.0 - 1.0;
	screenPosition.y = screenPosition.y * -2.0 + 1.0;

	gl_Position = vec4(screenPosition, 0.0f, 1.0f);	
	TexCoord = aTexCoord;
}